<?php

error_reporting(E_ALL);
ini_set('display_errors', 'on');
require_once ('vendor/autoload.php');


use Xsolla\SDK\Webhook\WebhookServer;
use Xsolla\SDK\Webhook\Message\Message;
use Xsolla\SDK\Exception\Webhook\XsollaWebhookException;
require 'includes/classes/Database.class.php';

$callback = function (Message $message) {
    switch ($message->getNotificationType()) {
        case Message::USER_VALIDATION:
		$userArray = $message->getUser();
        $userId = $message->getUserId();
        $messageArray = $message->toArray();
		
		Database::get()->select("SELECT * FROM %%USERS%% WHERE id = :id", array(
			':id' => $userId,
		));
		if(Database::get()->rowCount() == 0)
		{
			throw new Xsolla\SDK\Exception\Webhook\InvalidUserException('User not accepted');
		}
            break;
        case Message::PAYMENT:
		$userArray = $message->getUser();
        $paymentArray = $message->getTransaction();
        $paymentId = $message->getPaymentId();
        $externalPaymentId = $message->getExternalPaymentId();
        $paymentDetailsArray = $message->getPaymentDetails();
        $customParametersArray = $message->getCustomParameters();
        $isDryRun = $message->isDryRun();
        $messageArray = $message->toArray();
        $getPurchase = $message->getPurchase();
			
		Database::get()->update("UPDATE %%USERS%% SET darkmatter = darkmatter + :darkmatter WHERE id = :id", array(
			':darkmatter'	=> $getPurchase['virtual_currency']['quantity'],
			':id'			=> $userArray['id'],
		));
            break;
        case Message::REFUND:
            /** @var Xsolla\SDK\Webhook\Message\RefundMessage $message */
            // TODO if you cannot handle the refund, you should throw Xsolla\SDK\Exception\Webhook\XsollaWebhookException
            break;
        default:
            throw new XsollaWebhookException('Notification type not implemented');
    }
};

$webhookServer = WebhookServer::create($callback, 'PROJECT_KEY');
$webhookServer->start();

